#include <stdio.h>
#include <string.h>

#include <mpi.h>
int len = 0;
char** sargs = 0;
int sargc ;

#include "MPI.h"

/*
 * Class:     MPI
 * Method:    InitNative
 * Signature: ([Ljava/lang/String;)V
 */
JNIEXPORT void JNICALL Java_MPI_InitNative
  (JNIEnv *env, jclass obj, jobjectArray argv)
{
  jsize i;
  jstring jc;
  int flag ; /* debug */
  len = (*env)->GetArrayLength(env,argv) ;

  /*sargc = len + 2 ;*/
  sargc = len + 1 ;
  printf("len = %d, sargc = %d \n", len ,sargc);

  /*sargs = (char**)calloc(len + 3, sizeof(char*));*/
  sargs = (char**)calloc(1, sizeof(char*));
  /*sargs [0] = "java" ;*/
  sargs [0] = "test" ;
  /*  for (i=0; i<len; i++) {
    jc=(jstring)(*env)->GetObjectArrayElement(env,argv,i);
    sargs[2 + i]= (char*)calloc(strlen((*env)->GetStringUTFChars(env,jc,0))+1,
				sizeof(char));
    strcpy(sargs[2 + i],(*env)->GetStringUTFChars(env,jc,0));
  }
  */
  printf("argc=%d\n",sargc);
  /*  for (i=0; i<sargc; i++) {
    printf("sargs[%d] = %s\n",i,sargs[i]);
  }
  */
  printf("Before MPI_Initialized ...\n");  /* debug */
  MPI_Initialized(&flag) ;  /* debug */
  printf("After MPI_Initialized... flag = %d\n", flag);

  printf("Before MPI_Init ...\n");
  MPI_Init(&sargc, &sargs);
  printf("After MPI_Init...\n");
}                                                   

/*
 * Class:     MPI
 * Method:    Finalize
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_MPI_Finalize
  (JNIEnv *env, jclass obj) {
  int i;

  printf("MPIFinalize...\n");

  MPI_Finalize();

  for (i=0; i<len; i++)
    free(sargs[i]);

  free(sargs);                            
}
                                             
